//+------------------------------------------------------------------+
//|                                                     RoughSMI.mq4 |
//|                                         Copyright  2007, Candyd |
//|                                         http://www.alpari-idc.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Candyd"
#property link      "http://www.alpari-idc.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_level1 0.0
#property indicator_levelcolor Maroon
#property indicator_levelwidth 1
#property indicator_levelstyle 3
//---- input parameters
extern int       q=64;
extern int       r=32;
extern int       s=5;

//---- buffers
double SMIBuffer[];
double SumExtremum[];
double DifExtremum[];
double FirstEMASum[];
double FirstEMADif[];
double SecondEMASum[];
double SecondEMADif[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(7);
   string parameters;
   parameters=StringConcatenate("(",q,")"); 

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SMIBuffer);
   SetIndexLabel(0,"SMI"+parameters);
   SetIndexDrawBegin(0,q);
     
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,FirstEMASum); 
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,FirstEMADif);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(3,SumExtremum);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,DifExtremum);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,SecondEMASum);
   SetIndexStyle(6,DRAW_NONE);
   SetIndexBuffer(6,SecondEMADif);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int i,limit;
   if (counted_bars>0) limit=Bars-counted_bars;
   limit--;
   if (counted_bars==0) 
      {
      limit=Bars-counted_bars;
      for (i=Bars-1;i>=0;i--) 
         {
         SMIBuffer[i]=0.0;
         SumExtremum[i]=0.0;
         DifExtremum[i]=0.0;
         FirstEMASum[i]=0;
         FirstEMADif[i]=0;
         SecondEMASum[i]=0;
         SecondEMADif[i]=0;
         }
      for (i=Bars-q;i>=0;i--)
         {
         SumExtremum[i]=Close[i]-0.5*(High[iHighest( Symbol(), 0, 2, q, i)]+Low[iLowest( Symbol(), 0, 1, q, i)]);
         DifExtremum[i]=(High[iHighest( Symbol(), 0, 2, q, i)]-Low[iLowest( Symbol(), 0, 1, q, i)]);
         }
      for (i=Bars-q;i>=0;i--)
         {
         FirstEMASum[i]=iMAOnArray(SumExtremum,0,r,0,MODE_EMA,i);
         FirstEMADif[i]=iMAOnArray(DifExtremum,0,r,0,MODE_EMA,i);
         }
      for (i=Bars-q;i>=0;i--)
         {
         SecondEMASum[i]=iMAOnArray(FirstEMASum,0,s,0,MODE_EMA,i);
         SecondEMADif[i]=iMAOnArray(FirstEMADif,0,s,0,MODE_EMA,i);
         if (SecondEMADif[i]!=0) SMIBuffer[i]=200*SecondEMASum[i]/SecondEMADif[i];
         else SMIBuffer[i]=0.0;
         }
      return(0);
      }
   //Print(" ");
   for (i=limit;i>=0;i--)
         {
         SumExtremum[i]=Close[i]-0.5*(High[iHighest( Symbol(), 0, 2, q, i)]+Low[iLowest( Symbol(), 0, 1, q, i)]);
         DifExtremum[i]=(High[iHighest( Symbol(), 0, 2, q, i)]-Low[iLowest( Symbol(), 0, 1, q, i)]);
         }
   for (i=limit;i>=0;i--)
         {
         FirstEMASum[i]=iMAOnArray(SumExtremum,0,r,0,MODE_EMA,i);
         FirstEMADif[i]=iMAOnArray(DifExtremum,0,r,0,MODE_EMA,i);
         }
   for (i=limit;i>=0;i--)
         {
         SecondEMASum[i]=iMAOnArray(FirstEMASum,0,s,0,MODE_EMA,i);
         SecondEMADif[i]=iMAOnArray(FirstEMADif,0,s,0,MODE_EMA,i);
         if (SecondEMADif[i]!=0) SMIBuffer[i]=200*SecondEMASum[i]/SecondEMADif[i];
         else SMIBuffer[i]=0.0;
         }
//----
   return(0);
  }
//+------------------------------------------------------------------+